// simple test of when TLS callbacks execute
// 2008 andrewl
//
// 99% of code from:
// skywing (http://www.nynaeve.net/?p=180)
// cdman83 (http://hype-free.blogspot.com/2008/10/playing-tricks-with-windows-pe-loader.html)
//
// you should see this printed by the TLS callback
//
// h:00400000 dwReason:00000001 pv:00000000 <-- DLL_PROCESS_ATTACH (main thread created)
// (main thread begins execution)
// h:00400000 dwReason:00000002 pv:00000000 <-- DLL_THREAD_ATTACH (proc_Thread created)
// (proc thread executes for 1 second)
// h:00400000 dwReason:00000003 pv:00000000 <-- DLL_THREAD_DETACH (proc_Thread destroyed)
// h:00400000 dwReason:00000002 pv:00000000 <-- DLL_THREAD_ATTACH (proc_Thread created)
// (proc thread executes for 1 second)
// h:00400000 dwReason:00000003 pv:00000000 <-- DLL_THREAD_DETACH (proc_Thread destroyed)
// (main thread ends execution)
// h:00400000 dwReason:00000000 pv:00000000 <-- DLL_PROCESS_DETACH (main thread destroyed)
//

// OS
#include <windows.h>

// cstdlib
#include <stdio.h>

void NTAPI proc_TlsCallback(void* h, DWORD dwReason, PVOID pv)
{
    char buff[256];
    wsprintfA(buff, "h:%08X dwReason:%08X pv:%08X\n", h, dwReason, pv);
    MessageBoxA(0, buff, "hi", 0);
    Sleep(1000);
}

DWORD WINAPI proc_Thread(PVOID param)
{
    printf("Thread here:\n");

    return 0;
}


void main(void)
{ 
    HANDLE hThread;

    hThread = CreateThread(0, 0, proc_Thread, 0, 0, 0);
    WaitForSingleObject(hThread, INFINITE);
    CloseHandle(hThread);

    hThread = CreateThread(0, 0, proc_Thread, 0, 0, 0);
    WaitForSingleObject(hThread, INFINITE);
    CloseHandle(hThread);
}

extern "C"
{
    ULONG __tls_index__ = 0;

    #pragma section(".tls$zzz", read, write, execute)
    __declspec(allocate(".tls$zzz"))
    char __tls_end__ = 0;
    
    #pragma section(".tls", read, write, execute)
    __declspec(allocate(".tls"))
    char __tls_start__ = 0;

    #pragma section(".CRT$XLA")
    __declspec(allocate(".CRT$XLA"))
    PIMAGE_TLS_CALLBACK __crt_xl_start__ = 0;

    #pragma section(".CRT$XLB")
    __declspec(allocate(".CRT$XLB"))
    PIMAGE_TLS_CALLBACK __crt_xl_tls_callback__ = proc_TlsCallback;

    #pragma section(".CRT$XLZ")
    __declspec(allocate(".CRT$XLZ"))
    PIMAGE_TLS_CALLBACK __crt_xl_end__ = 0;
}

#pragma section(".rdata$T", read, write, execute)
__declspec(allocate(".rdata$T"))
extern "C" const IMAGE_TLS_DIRECTORY32 _tls_used =
{
    (DWORD) &__tls_start__,
    (DWORD) &__tls_end__,
    (DWORD) &__tls_index__,
    (DWORD) (&__crt_xl_start__+1),
    (DWORD) 0,
    (DWORD) 0
};

